clamp1_width = 20;
clamp1_length = 50;
clamp1_height = 10;
wall_thickness = 3;
gap_size = 6;
hole_diameter = 5.5;


//Holder 1 + 2
for(i=[0:1:1]){
  translate([-i * 25, 0, 0]){
    //base
    difference(){
      cube(size = [clamp1_width, clamp1_length, wall_thickness], center = true);
      translate([0, clamp1_length / 2, 0]){
        cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
      }
      translate([0, -clamp1_length / 2, 0]){
        cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
      }
    }
    //screw holes
    translate([0, clamp1_length / 2, 0]){
      difference(){
        cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
        cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
      }
    }
    translate([0, -clamp1_length / 2, 0]){
      difference(){
        cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
        cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
      }
    }
    //holder
    translate([0, (wall_thickness + gap_size) / 2, clamp1_height / 2]){
      cube(size = [clamp1_width, wall_thickness, clamp1_height], center = true);
    }
    translate([0, -(wall_thickness + gap_size) / 2, clamp1_height / 2]){
      cube(size = [clamp1_width, wall_thickness, clamp1_height], center = true);
    }
    translate([-(clamp1_width) / 4, 0, clamp1_height / 2]){
      cube(size = [clamp1_width / 2, wall_thickness * 2 + gap_size, clamp1_height], center = true);
    }
  }
}

//Holder 3
translate([25, 0, 0]){
  //base
  difference(){
    cube(size = [clamp1_width, clamp1_length, wall_thickness], center = true);
    translate([0, clamp1_length / 2, 0]){
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
    translate([0, -clamp1_length / 2, 0]){
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  //screw holes
  translate([0, clamp1_length / 2, 0]){
    difference(){
      cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  translate([0, -clamp1_length / 2, 0]){
    difference(){
      cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  //holder
  translate([0, 0, clamp1_height / 2]){
    difference(){
    cube(size = [clamp1_width, clamp1_width, clamp1_height], center = true);
      rotate([0, 0, 60]){
        translate([-wall_thickness, 0, 0]){
          cube(size = [clamp1_width, gap_size, clamp1_height * 1.01], center = true);
        }
      }
    }
  }  
  
}

//Holder 4
translate([50, 0, 0]){
  //base
  difference(){
    cube(size = [clamp1_width, clamp1_length, wall_thickness], center = true);
    translate([0, clamp1_length / 2, 0]){
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
    translate([0, -clamp1_length / 2, 0]){
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  //screw holes
  translate([0, clamp1_length / 2, 0]){
    difference(){
      cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  translate([0, -clamp1_length / 2, 0]){
    difference(){
      cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  //holder
  translate([0, 0, clamp1_height / 2]){
    difference(){
    cube(size = [clamp1_width, clamp1_width, clamp1_height], center = true);
      rotate([0, 0, 120]){
        translate([-wall_thickness, 0, 0]){
          cube(size = [clamp1_width, gap_size, clamp1_height * 1.01], center = true);
        }
      }
    }
  }  
  
}


//Filament guide
translate([-50, 0, 0]){
  //base
  difference(){
    cube(size = [clamp1_width, clamp1_length, wall_thickness], center = true);
    translate([0, clamp1_length / 2, 0]){
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  //Filament hole
  translate([0, clamp1_length / 2, 0]){
    difference(){
      cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
      cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
    }
  }
  //holder
  translate([0,  -(clamp1_length + wall_thickness) / 2 , 10 / 2 - wall_thickness / 2]){
    cube(size = [6.0, 6.0 + wall_thickness, 10], center = true);
  }

  translate([0,  -(clamp1_length - wall_thickness) / 2 , clamp1_width / 2]){
    difference(){
    cube(size = [clamp1_width, wall_thickness, clamp1_width], center = true);
      rotate([90, 0, 0]){
        translate([0, clamp1_width / 2, 0]){
          cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
        }
      }
    }
    rotate([90, 0, 0]){
      translate([0, clamp1_width / 2, 0]){
        difference(){
          cylinder ($fn = 200, r = clamp1_width / 2, h = wall_thickness, center = true);
          cylinder ($fn = 200, r = hole_diameter / 2, h = wall_thickness * 1.01, center = true);
        }
      }
    }

  }  
  
}
